#include "incs.h"
#include "bin_data.h"
#include "utils.h"

Bin_Data::Bin_Data (FILE* bin_data_file, int num_points, 
			int num_inputs, int num_targets ):
  bin_data_fp(bin_data_file),
  n_points(num_points),
  n_inputs(num_inputs+1),
  n_targets(num_targets)
{
  input_matrix = RealMatrix2(n_points, n_inputs);
  target_matrix = RealMatrix2(n_points, n_targets);
  if(n_targets == 2)
	n_targ = 1;
  float tmp;
  for(int point = 0; point < n_points; point ++){
    input_matrix[point][0] = 1.0;
    for(int ipdim = 1; ipdim < n_inputs; ipdim ++){
      if(feof(bin_data_fp))
	error(1, "End of bin_data file !\n");
      fscanf(bin_data_fp,"%f",&tmp);
      input_matrix[point][ipdim] = (real) tmp;
    }
    for(int opdim = 0; opdim < n_targ; opdim ++){
      if(feof(bin_data_fp))
		error(1, "End of bin_data file !\n");
      fscanf(bin_data_fp,"%f",&tmp);
	  if(n_targ == 1) {
		if(tmp == 0) {
		  target_matrix[point][0] = 0;
		  target_matrix[point][1] = 1;
		}
		if(tmp == 1) {
		  target_matrix[point][0] = 0;
		  target_matrix[point][1] = 1;
		}
	  }
	  else
		target_matrix[point][opdim] = (real) tmp;
	}
  }
}

Bin_Data::~Bin_Data()
{
  
}

real Bin_Data::get_next_input ( int pointer, real* input )
{
  return input[pointer];
}

real Bin_Data::get_next_target ( int pointer, real* target )
{
  return target[pointer];
}

void Bin_Data::print ( )
{
  for(int point = 0; point < n_points; point ++){
    printf("inputs = ");
    for(int ipdim = 0; ipdim < n_inputs; ipdim ++){
      printf("%f ", input_matrix[point][ipdim]);
    }
    printf("\n");
    printf("targets = ");
    for(int opdim = 0; opdim < n_targets; opdim ++){
      printf("%f ", target_matrix[point][opdim]);
    }
    printf("\n");
  }
}


  
  
real** Bin_Data::get_inputs(int offset)
{
  return input_matrix + (offset*n_inputs);
}

real** Bin_Data::get_targets(int offset)
{
  return target_matrix + (offset*n_targets);
}

  
