#ifndef CONV_H
#define CONV_H

class Conv 
{
public: 
  Conv(double _tol = 1e-4,
	   int _max_its = 100,
	   int _avg_len = 3) {
	tol = _tol;
	max_its = _max_its;
	avg_len = _avg_len;
	avg_diff = 0.0;
	old_diff = 0.0;
	dub_diff = 0.0;
	av = 0.0;
	its = 0;
  };
  ~Conv();
  int test() {
	if((fabs(avg_diff > tol)) && (its > max_its))
	  return 0;
	else 
	  return 1;
  };
  void increment(double new_val) {
    double diff = fabs(new_val - old_val);
	if(its > 1) {
	  if((its % avg_len) == 0) {
		avg_diff = av / avg_len;
		dub_diff = fabs(old_diff - avg_diff);
		old_diff = avg_diff;
		av = 0.0;
	  }
	  av += diff;
	}
	old_val = new_val;
	its ++;
  };
private:
  int its;
  double tol;
  int max_its;
  int avg_len;
  double av; // an accumulator
  double avg_diff;
  double dub_diff;
  double old_diff;
  double old_val;
};

#endif


	   
