#include "incs.h"
#include "utils.h"
#include "functions.h"
#include "hme_utils.h"

void get_cv_set(real percent,
				int npoints,
				int n_input,
				int n_output,
				real** orig_inputs, real** orig_targets,
				real** trn_inp, real** trn_targ, 
				real** tst_inp, real** tst_targ,
				int* num_cv_train,
				int* num_cv_test) {
  int n_cv_train;
  int n_cv_test;
  real** rand_targ = RealMatrix2(npoints, n_output);
  real** rand_in = RealMatrix2(npoints, n_input+1);  
  int* map = IntVector(npoints);
  randomize_matrix_rows2(orig_targets, 
						 npoints, 
						 n_output, map,
						 rand_targ);
  remap_matrix_rows2(orig_inputs, npoints, 
					 n_input+1, map, rand_in);
  
  real** inputs = rand_in;
  real** targets = rand_targ;
  
  n_cv_train = (int) (npoints * percent);
  n_cv_test = npoints - n_cv_train;
  printf("train = %d, test = %d\n", n_cv_train, n_cv_test);

	for(int n1 = 0; n1 < n_cv_train; n1 ++) {
	  for(int i = 0; i < n_input+1; i ++) {
		trn_inp[n1][i] = inputs[n1][i];
	  }
	  for(int o = 0; o < n_output; o ++) {
		trn_targ[n1][o] = targets[n1][o];
	  }
	}
	for(int n3 = n_cv_train; n3 < npoints; n3 ++) {
	  for(int i = 0; i < n_input+1; i ++) {
		tst_inp[n3 - n_cv_train][i] = inputs[n3][i];
	  }
	  for(int o = 0; o < n_output; o ++) {
		tst_targ[n3 - n_cv_train][o] = targets[n3][o];
	  }
	}
	int verb = 0;
	if(verb > 0) {
	printf("train\n");
	for(int n = 0; n < n_cv_train; n ++) {
	  printf("%d ", n);
	  for(int i = 0; i < n_input+1; i ++) {
		printf("%f ", trn_inp[n][i]);
	  }
	  for(int o = 0; o < n_output; o ++) {
		printf("%f ", trn_targ[n][o]);
	  }
	  printf("\n");
	}
	printf("\n");
	printf("test\n");
	for(int n2 = 0; n2 < n_cv_test; n2 ++) {
	  printf("%d ", n2);
	  for(int i = 0; i < n_input+1; i ++) {
		printf("%f ", tst_inp[n2][i]);
	  }
	  for(int o = 0; o < n_output; o ++) {
		printf("%f ", tst_targ[n2][o]);
	  }
	  printf("\n");
	}
	printf("\n");
	}		
	*num_cv_train = n_cv_train;
	*num_cv_test = n_cv_test;
	FreeRealMatrix2(&rand_targ);
	FreeRealMatrix2(&rand_in);
	FreeIntVector(&map);
}


