#ifndef Net_H
#define Net_H

#include "network.h"

class Net : public Network
{
public: 
  Net(int n_batch, int num_ip, int num_op, int dbg);
  Net(const Net & old);
  Net(int n_batch, FILE* fp);
  int num_input() { return n_input;};
  int num_output() { return n_output;};
  void go_forward_batch(int N, real** in, real** out);
  void go_forward_batch(int N, real** in, real** out, real** m2);
  char* get_class() { return class_str;};


  virtual ~Net();
  virtual double train_params(int N) = 0;
  virtual double train_params(int N, real* weights) = 0;
  virtual double train(int N, real** in, 
		       real** targ) = 0;
  virtual double train(int N, real** in,
		       real** targ, real* weights) = 0;
  virtual void update_hyperparameters(int N, real** in, 
									  real** targ, real* weights) = 0;
  virtual void init(int N, real** in,
					real** targ, real* weights) = 0;
  virtual void randomize_weights(real offset) = 0;
  virtual void go_forward(real* in, real* out) = 0;
  virtual void go_forward_log(real* in, real* out) = 0;
  virtual void go_forward(real* in, real* out, real* m2) = 0;
  virtual void write_weights(FILE* fp) = 0;
  virtual void read_weights(FILE* fp) = 0;
  virtual double get_joint(real* in, real* targ) = 0;
  virtual double get_prior() = 0;
  virtual double* get_weights() = 0;
  virtual void set_weights(real* wts) = 0;
  virtual int get_num_weights() = 0;
  virtual double* get_grad(int n_points, real** in, real** targ) = 0;
  virtual real get_evidence(int n_points, real** in, real** targ,
							real* wts) = 0;
  virtual real get_sum_jposts(int n_points, real* wts) = 0;
protected:
  int size_batch;
  int n_input;
  int n_output;
  real likelihood;
  int debug;

  real** targets;
  real** inputs;
  real* jpost;

  real* tmp_op;
  real** tmp_op_vec;
  int batch_size;
  char* class_str;
};

#endif


