#ifndef NET_Class_H
#define NET_Class_H

#include "net.h"

class NET_Class : public Net
{
public:
  NET_Class(int n_batch, 
	    int num_ip, 
	    int num_op,
	    int dbg,
	    int _msteps,
	    real _tol);
  NET_Class(int n_batch, FILE* fp);
  NET_Class(const NET_Class& old);
  ~NET_Class();
  void go_forward(real* in, real* out);
  void go_forward_log(real* in, real* out);
  void go_forward(real* in, real* out, real* m2);
  double train(int n_points, real** in,real** targ) ;
  double train(int n_points, real** in, real** targ, real* weights);
  void randomize_weights(real offset);
  void randomize_weights2(real offset);
  void compute_gen_probs(int, real*);
  void write_weights(FILE* fp);
  void read_weights(FILE* fp);
  void get_gradient(double* grad);
  void get_gradient(double* grad, double* fn);
  double get_function();
  void compute_hessian(int n_points, 
					   real** in, 
					   real** out, 
					   real* wts,
					   real*** hess); 
  double get_joint(real* in, real* targ);
  real get_prior() {return 0;};
  real get_gen_prob(real* in, real* targ);
  double* get_weights() {return weights;};
  void set_weights(real* wts) { weights = wts;};
  int get_num_weights() {return n_weights;};
  void update_hyperparameters(int n_points, real** in, 
							  real** targ,
							  real* weights);
  void init(int n_points, real** in, real** targ, real* wts);
  real get_evidence(int n_points, real** in, real** targ,
							real* wts);
  real get_sum_jposts(int n_points, real* wts);
protected:
  int n_weights;
  int msteps;
  real tol;
  real* eta;
  double* weights;
  double* last_weights;
  double* dweights;
};

#endif

