#ifndef NET_Class_Mac_H
#define NET_Class_Mac_H

#include "net_class.h"
#include "macopt.h"

class NET_Class_Mac : public NET_Class, Macopt
{
public:
  NET_Class_Mac(int n_batch, 
		int num_ip, 
		int num_op,
		int dbg = 0,
		int _itmax = 10,
		int _msteps = 10,
		int _rich = 0,
		real _tol = 0.001);
  NET_Class_Mac(int n_batch, FILE* fp);
  NET_Class_Mac(const NET_Class_Mac & old);
  ~NET_Class_Mac();
  double train_params(int n_points);
  double train_params(int n_points, real* weights);
  double func(double* _p);
  void dfunc(double* _p, double* _g);
  double* get_grad(int n_points, real** in, real** targ);
private:
  int itmax;
  int rich;
  double* grad;
  double* mac_weights;
  double* old_weights;
};

#endif

