#ifndef NET_Regress_Mac_H
#define NET_Regress_Mac_H

#include "net_regress.h"
#include "macopt.h"

class NET_Regress_Mac : public NET_Regress, Macopt
{
public:
  NET_Regress_Mac(int n_batch, 
				  int num_ip, 
				  int num_op,
				  real _lambda,
				  real _prior_var,
				  int dbg = 0,
				  int _itmax = 10,
				  int _msteps = 10,
				  int _rich = 0,
				  real _tol = 0.001);
  NET_Regress_Mac(int n_batch, 
		  int num_ip, 
		  int num_op,
		  int dbg,
		  int _itmax,
		  int _msteps,
		  int _rich,
		  real _tol,
		  real _lambda,
		  real _prior_var,
				  real** in, real** out, real** targ);
  NET_Regress_Mac(int n_batch, FILE* fp);
  NET_Regress_Mac(const NET_Regress_Mac& old);
  ~NET_Regress_Mac();
  double train_params(int n_points) ;
  double train_params(int n_points, real* weights) ;
  double func(double* _p);
  void dfunc(double* _p, double* _g);
  double* get_grad(int n_points, real** in, real** targ);
private:
  int itmax;
  int rich;
  double* mac_weights;
  double* old_weights;
  double* grad;

};

#endif

