#ifndef NET_UTILS_H
#define NET_UTILS_H

#include "network.h"
Network* get_new_net(int size_batch, FILE* fp, char* net_class);
Network* get_new_net(Network* old_net);
Network* new_class_net(int ensemble,
					   int num_train,
					   int n_input,
					   int num_outputs);
Network* get_new_class_net(int use_ensemble,
						   int optim_type,
						   int num_train,
						   int n_input,
						   int num_outputs,
						   int optim_iterations,
						   int msteps,
						   int optim_richness,
						   real optim_tolerance,
						   int hyper_epochs,
						   int debug);
Network* get_new_reg_net(int xprt_ensemble,
						 int xprt_optim,
						 int num_train,
						 int n_input,
						 int n_output,
						 int debug,
						 int optim_iterations,
						 int msteps,
						 int optim_richness,
						 real optim_tolerance,
						 real lambda,
						 real prior_var,
						 int xprt_hyper_epochs);
void guess_class_scale(int n_points, int n_input, real** inputs, 
				 real** targets, real* scale);
int test_prune(real* jp, int n);
#endif
