#ifndef Network_H
#define Network_H


class Network
{
public: 
  virtual ~Network() {};
  virtual int num_input() = 0;
  virtual int num_output()= 0;
  virtual void randomize_weights(real offset) = 0;
  virtual void randomize_weights2(real offset) = 0;
  virtual void go_forward(real* in, real* out) = 0;
  virtual void go_forward_log(real* in, real* out) = 0;
  virtual void go_forward_batch(int n_points, real** in, real** out) = 0;
  virtual void go_forward(real* in, real* out, real*m2) = 0;
  virtual void go_forward_batch(int n_points, real** in, real** out,
								real** m2) = 0;
  virtual double train_params(int n_points) = 0;
  virtual double train_params(int n_points, real* weights) = 0;
  virtual void update_hyperparameters(int n_points, real** in, 
									  real** targ, real* weights) = 0;

  virtual double train(int n_points, real** in, real** targ) = 0;
  virtual double train(int n_points, real** in, real** targ, real* weights) = 0;
  virtual void init(int n_points, real** in, 
					real** targ, real* weights) = 0;
  virtual double get_joint(real* in, real* targ) = 0;
  virtual double get_prior() = 0;
  virtual void write_weights(FILE* fp) = 0;
  virtual void read_weights(FILE* fp) = 0;
  virtual char* get_class() = 0;
  virtual double* get_weights() = 0;
  virtual void set_weights(double* wts) = 0;
  virtual int get_num_weights() = 0;
  virtual double* get_grad(int n_points, real** in, real** targ) = 0;
  virtual real get_evidence(int n_points, real** in, real** targ,
							real* wts) = 0;
  virtual real get_sum_jposts(int n_points, real* wts) = 0;
};

#endif


