#include "tree.h"


void Tree::grow_ens_train(int n_epochs, real** inputs, real** targets, 
						  FILE* fp_out, int npoints) {
  
  //  train_params(n_epochs, 0, inputs, targets, fp_out, npoints);
  ens_train(100, 0, 10, inputs, targets, fp_out, npoints);
  real last_err = FLT_MAX;
  real err = compute_error(npoints, inputs, targets);
  double evidence = get_evidence(npoints, inputs, targets);
  int iter = 0;
  double last_evidence = -FLT_MAX;
  double best_evidence = evidence;
  rewind(fp_out);
  write_weights(fp_out);
  fflush(fp_out);
  while((evidence > last_evidence) || (iter < 4)){
	printf("\n---------\n split %d\n -------\n", iter);
	split_nodes_hard(npoints, inputs, targets);
	ens_train(100, 0, 100, inputs, targets, fp_out, npoints);
	last_err = err;
	err = compute_error(npoints, inputs, targets);
	get_ens_posts(npoints, inputs, targets);
	double log_like = like;
	double aux_like = aux;
	iter ++;
	last_evidence = evidence;
	evidence = get_evidence(npoints, inputs, targets);
	if(evidence > best_evidence) {
	  best_evidence = evidence;
	  rewind(fp_out);
	  write_weights(fp_out);
	  fflush(fp_out);
	  printf("writing weights\n");
	}
	printf("iter %d err = %f, aux = %f, like = %f ev = %f last = %f\n", 
		   iter, err, aux_like, log_like, evidence, last_evidence);
  }
} 
