#include "tree.h"

// ------------------------------------------------------------
// I/O stuff
// ------------------------------------------------------------


void Tree::write_weights(FILE* fp)
{
  fprintf(fp, "%s\n", class_str);
  fprintf(fp, "%d %d\n", n_input, n_output);
  node->write_weights(fp);
}

void Tree::read_weights(FILE* fp)
{
  fscanf(fp, "%s\n", class_str);
  fscanf(fp, "%d %d\n", &n_input, &n_output);
  node->read_weights(fp);
}

void Tree::write_predictions(FILE* fp,
							 int n_points,
							 real** pred) {
  for(int n = 0; n < n_points; n ++) {
    for(int i =0; i < n_output; i ++){
      fprintf(fp,"%f ", pred[n][i]);
    }
    fprintf(fp,"\n");
  }
}



void Tree::print_posteriors(int n_points) {
  for(int point = 0; point < n_points; point ++){
    node->print_posteriors(point);
  }
}

