#include "incs.h"
#include "tst_data.h"
#include "utils.h"

TST_Data::TST_Data (FILE* data_file, int num_points, int num_inputs):
  data_fp(data_file),
  n_points(num_points),
  n_inputs(num_inputs+1)
{
  input_matrix = RealMatrix2(n_points, n_inputs);
  float tmp;
  for(int point = 0; point < n_points; point ++){
    input_matrix[point][0] = 1.0;
    for(int ipdim = 1; ipdim < n_inputs; ipdim ++){
      if(feof(data_fp))
	error(1, "End of data file !\n");
      fscanf(data_fp,"%f",&tmp);
      input_matrix[point][ipdim] = (real) tmp;
    }
  }
}

TST_Data::~TST_Data()
{
  FreeRealMatrix2(&input_matrix);
}

real TST_Data::get_next_input ( int pointer, real* input )
{
  return input[pointer];
}

void TST_Data::print ( )
{
  for(int point = 0; point < n_points; point ++){
    printf("inputs = ");
    for(int ipdim = 0; ipdim < n_inputs; ipdim ++){
      printf("%f ", input_matrix[point][ipdim]);
    }
    printf("\n");
  }
}
  
real** TST_Data::get_inputs(int offset)
{
  return input_matrix + (offset*n_inputs);
}
